//implement remote virtual,protection proxy
//author: Weiheng
//using for the presentation of 776
//The code I show in the class using professor's communication channel,this is the code run locally
/////////////////////////////////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <iostream>
#include<string>
//what problem can the Proxy pattern solve:
//1.access to an object should be controlled
//2.additional functionality should be provided when accessing
//objects, for example, it should be possible to check that
//clients have the needed access right.
//three uses of proxy:
//1.remote proxy
//2.virtual proxy
//3.protection proxy


/*define an interface for ProxyDoc, LocalDoc and RemoteDoc*/
class IDoc {
public:
	virtual void ShowDoc() = 0;
	virtual void ModifyDoc(int c) = 0;
	virtual const int GetCount()=0;
};
/*define end*/

/*Remote Document*/
class RemoteDoc : public IDoc {
private:
	int count=0;
public:
	void ShowDoc() {
		std::cout << "This is the remote Document!" << " The count is " + std::to_string(count) << std::endl;
	}

	void ModifyDoc(int c) {
		std::cout << "The count of remote Document change from " + std::to_string(count) + " to " + std::to_string(c) << std::endl;
		count = c;
	}

	const int GetCount() {
		return count;
	}
};
/*Remote Document end*/

/*Local Document*/
class LocalDoc : public IDoc {
private:
	IDoc *remotedoc_;
	int count;

public:
	LocalDoc(IDoc* remotedoc)  {
		remotedoc_ = remotedoc;	
		count = remotedoc_->GetCount();
	}
	~LocalDoc() {
	}

	void ShowDoc() {
		std::cout << "This is the local Document!" << " The count is " + std::to_string(count) << std::endl;
	}

	void ModifyDoc(int c) {
		std::cout << "The count of local Document change from " + std::to_string(count) + " to " + std::to_string(c) << std::endl;
		count = c;
		remotedoc_->ModifyDoc(c);//upload the new count to remote document
	}

	const int GetCount() {
		return count;
	}

};
/*Local Document end*/

/*Proxy Local Doc*/
class ProxyDoc : public IDoc {
private:
	std::string username_;
	IDoc *localdoc_;
public:
	ProxyDoc(IDoc* localdoc,std::string name) {
		localdoc_ = localdoc;
		username_ = name;
	}
	~ProxyDoc() {
	}

	void ShowDoc() {
		if (username_ != "admin1" && username_ != "admin2") {
			std::cout << "Access denied, only admin1 and admin2 can show the document" << std::endl;
		}
		else {
			localdoc_->ShowDoc();
		}
	}

	void ModifyDoc(int c) {
		if (username_ != "admin1" ) {
			std::cout << "Access denied, only admin1 can modify the document" << std::endl;
		}
		else {
			localdoc_->ModifyDoc(c);
		}
	}

	const int GetCount() {
		return 0;
	}
};
/*ProxyDoc end*/





int main() {
	/*ICar* babycar = new Car();
	babycar->DriveCar();
	ICar* car = new ProxyCar(16);
	car->DriveCar();
	delete car;

	car = new ProxyCar(25);
	car->DriveCar();
	delete car;*/
	IDoc* rdoc = new RemoteDoc();
	IDoc* ldoc = new LocalDoc(rdoc);
	IDoc* pdoc = new ProxyDoc(ldoc, "admin3");
	IDoc* pdoc1 = new ProxyDoc(ldoc, "admin2");
	IDoc* pdoc2 = new ProxyDoc(ldoc, "admin1");
	pdoc->ShowDoc();
	pdoc->ModifyDoc(3);
	pdoc1->ShowDoc();
	pdoc2->ModifyDoc(5);
	getchar();
	getchar();
}